package dal

import (
	"octopus/internal/config"
	"octopus/pkg/storage"
	"sync"

	"github.com/rs/zerolog/log"
	// pb "github.com/qdrant/go-client/qdrant"
)

var (
	storageOnce     sync.Once
	storageInstance *storage.Storage
)

func GetStorage() *storage.Storage {
	storageOnce.Do(initMinio)
	return storageInstance
}

func initMinio() {
	log.Info().Msg("loading minio configs")

	s, err := storage.NewObjectStorage(config.Get().Databases.Storage)
	if err != nil {
		log.Fatal().Msgf("storage client init failed: %v", err)
	}

	storageInstance = s
}
